package com.link.core.mq.cmq.Tools;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLSession;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class CMQHttp {
   protected static int timeout = 10000;
   protected static boolean isKeepAlive = true;
   private static final Logger logger = LogManager.getLogger(CMQHttp.class);

   public static String request(String method, String url, String req, int userTimeout) throws Exception {
      String result = "";
      BufferedReader in = null;

      try {
         URL realUrl = new URL(url);
         URLConnection connection = null;
         if (url.toLowerCase().startsWith("https")) {
            HttpsURLConnection httpsConn = (HttpsURLConnection)realUrl.openConnection();
            httpsConn.setHostnameVerifier(new HostnameVerifier() {
               public boolean verify(String hostname, SSLSession session) {
                  return hostname.equalsIgnoreCase(session.getPeerHost());
               }
            });
            connection = httpsConn;
         } else {
            connection = realUrl.openConnection();
         }

         ((URLConnection)connection).setRequestProperty("Accept", "*/*");
         if (isKeepAlive) {
            ((URLConnection)connection).setRequestProperty("Connection", "Keep-Alive");
         }

         ((URLConnection)connection).setRequestProperty("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
         ((URLConnection)connection).setConnectTimeout(timeout + userTimeout);
         if ("POST".equals(method)) {
            ((HttpURLConnection)connection).setRequestMethod("POST");
            ((URLConnection)connection).setDoOutput(true);
            ((URLConnection)connection).setDoInput(true);
            DataOutputStream out = new DataOutputStream(((URLConnection)connection).getOutputStream());
            out.writeBytes(req);
            out.flush();
            out.close();
         }

         ((URLConnection)connection).connect();
         int status = ((HttpURLConnection)connection).getResponseCode();
         if (status != 200) {
            throw new CMQServerException(status);
         }

         String line;
         for(in = new BufferedReader(new InputStreamReader(((URLConnection)connection).getInputStream(), "utf-8")); (line = in.readLine()) != null; result = result + line) {
         }
      } catch (Exception var17) {
         Exception e = var17;
         throw e;
      } finally {
         try {
            if (in != null) {
               in.close();
            }
         } catch (Exception var16) {
            Exception e2 = var16;
            logger.error("CMQHttp捕获异常: ", e2);
         }

      }

      return result;
   }
}
